def P(x):
    return x**5 + 3*x**4 + x**3 - 7*x - 6

def trova_zero_A(f,a,b):
  eps = 1 / 1000000
  x = a
  steps=1
  while x <= b:
    if f(x) == 0.0 or f(x)*f(x+eps)<0:
      print("Trovato in {1} passi lo zero {0}.".format(x,steps))
      print(" f({}) = {}".format(x,f(x)))
      print(" f({}) = {}".format(x+eps,f(x+eps)))
      return
    steps +=1
    x += eps

import math
def T(x):
    return x + math.cos(x)

def trova_zero_B(f,a,b):
    eps=1/1000000
    passi = 0
    start,end = a,b
    while end - start > eps :

        mid   = (start + end)/2
        passi = passi + 1

        if f(mid) == 0.0:
            start = mid
            end   = mid
        elif f(start)*f(mid) < 0:
            end   = mid
        else:
            start = mid
           
            
    print("Trovato in {1} passi lo zero {0}.".format(start,passi))
    print(" f({}) = {}".format(start,f(start)))
    print(" f({}) = {}".format(end,f(end)))

trova_zero_B(P,-2.0,1.0)
trova_zero_B(T,-4.0,4.0)

def ricercasequenziale(x,seq):
    for i in range(len(seq)):
        if x==seq[i]:
            print("Trovato l'elemento dopo {} passi.".format(i+1))
            return 
    print("Non trovato. Eseguiti {} passi.".format(len(seq)))

import random
def test_ricerca(S,sorted=False):
    t = 0
    size=2000000
    N   =1000000
    seq = [random.randint(-size,size) for _ in range(N)]
    if sorted:
        seq.sort()
    S(0,seq)

def ricercabinaria(x,seq):
    start=0
    end=len(seq)-1
    step = 0
    while start<=end:
        step += 1
        mid = (end + start) // 2
        half = seq[mid]
        if half == x:
            print("Trovato l'elemento dopo {} passi.".format(step))
            return 
        elif half < x:
            start = mid + 1
        else:
            end = mid-1
    print("Non trovato. Eseguiti {} passi.".format(step))
